﻿@using System.Web.Mvc;
@using System.Web.UI.WebControls;
@using System.Data;
@using Portal.Controllers;

@model Toyota.Common.Web.MVC.ModelHolder
                       
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

@* wot.dwi 08/11/2012  *@ 
@* fid.salman 03/05/2013 *@ 

@section StartupScript{
    GRIDGridView.Refresh();
    
    $.ajax({
        type: "POST",
        url: "@Url.Content("~/GoodsReceiptInquiry/GetManifestPostMaxData")",
        data: {   
        },
        success: function (result) { 
            MAX_GR_POST = result;
        },
        error: function (result) {
            MAX_GR_POST = result;
        }
    });  


    $.ajax({
        type: "POST",
        url: "@Url.Content("~/GoodsReceiptInquiry/GetSplitMaxData")",
        data: {   
        },
        success: function (result) { 
            MAX_GR_PERPROCESS = result;
        },
        error: function (result) {
            MAX_GR_PERPROCESS = result;
        }
    });

    @*GRIHStatusLookup.SetValue('Scanned');    
    GridGRIHStatusLookup.SelectRowsByKey(new Array('Scanned'));*@
}

@section Script {    
}


@section SlidingRightPaneContent {    
    @Html.Partial("GoodsReceiptInquiryManifestStatusSummaryPartial", Model)
}

@section SlidingLeftPaneContent {
    @*<div id="GoodsReceiptInquiryErrorPIC" style="position:absolute;padding-bottom:10px;height:100%;width:100%;">
    @Html.Action("PartialGoodsReceiptErrorPIC", "GoodsReceiptInquiry")
    </div>*@
}

<script type="text/javascript"> 
    $(window).load(function(){
        GRIHClearButton.DoClick();
    });
    // ============================= Common Variables ============================

    var arrivalTimeFrom = "";
    var arrivalTimeTo = "";

    var dockCode = "";
    var supplierCode = "";
    var rcvPlantCode = "";
    var routeRate = "";
    var manifestNo = "";
    var manifestReceiveFlag = "";
    var orderNo = "";

    var updateAction = "";

    var MAX_GR_POST = "";

    var MAX_GR_PERPROCESS = "";

    // ===========================================================================

    // ============================= Common Functions ============================

    function GetDatabaseFormatDate(regularFormatDate) {
        var date = regularFormatDate.getDate();
        var month = regularFormatDate.getMonth() + 1;
        var year = regularFormatDate.getFullYear();

        return year + "-" + month + "-" + date;
    }

    function GetRegularFormatDate(databaseFormatDate) {
        var date = databaseFormatDate.split("-")[2]
        var month = databaseFormatDate.split("-")[1]
        var year = databaseFormatDate.split("-")[0]

        return date + "." + month + "." + year;
    }

    // ===========================================================================

    // ================== Goods Receipt Inquiry Header Functions =================

    function OnGRIHDownloadButtonClick(s, e) {
        if (GRIDGridView.GetVisibleRowsOnPage() == 0)
        {
            alert("No data to download");
        }
        else
        {
//            if (GRIHSupplierLookup.GetValue() == '' || GRIHSupplierLookup.GetValue() == null) {
//                alert("Supplier can't be empty");
//            } else {
                arrivalTimeFrom = GetDatabaseFormatDate(GRIHFromDate.GetDate());
                arrivalTimeTo = GetDatabaseFormatDate(GRIHToDate.GetDate());
                dockCode = GRIHDockLookup.GetText();
                supplierCode = GRIHSupplierLookup.GetText();
                rcvPlantCode = GRIHRcvPlantCodeText.GetText();
                routeRate = GRIHRouteRateText.GetText();
                manifestNo = GRIHManifestNoText.GetText();
                manifestReceiveFlag = GRIHStatusLookup.GetValue();
                orderNo = GRIHOrderNoText.GetText();
        
                GoodsReceiptInquiryDownloadConfirmationPopup.Show();
//            }
        }
    }
    
    function OnGRIHSHApproveButtonClick(s, e) {
        updateAction = "Approve";
        
        if (GRIDGridViewSelectAllCheckBox.GetChecked())
            $("#GRIUCPMessageLabel").text("Are you sure want to approve all data in all page?");
        else
            $("#GRIUCPMessageLabel").text("Are you sure want to approve?");

        GoodsReceiptInquiryUpdateConfirmationPopup.Show();
    }
    
    function OnGRIHCancelGRManifestButtonClick(s, e) {
        updateAction = "Cancel";

        $("#GRIUCPMessageLabel").text("Are you sure want to cancel?");
        GoodsReceiptInquiryUpdateConfirmationPopup.Show();
    }

    function OnGRIHToggleDetailButtonClick(s, e) {
        GRIDGridView.PerformCallback('ToggleColumns=TRUCK_ARRIVAL;MANIFEST_RECEIVING;FINANCIAL_DOCUMENT;SUPPLIER_INVOICE;CANCELLATION;CREATED');
    }
    
    function OnGRIHSummaryButtonClick(s, e) {
    }

    function OnGRIHSearchButtonClick(s, e) { 
        if (GRIHStatusLookup.GetValue())
        {
            GRIDGridView.PerformCallback(); 
        }
        else
        {
            WarningLabel.SetVisible(true);
        }
    }
     
    function OnGRIHClearButtonClick(s, e) {
        var yesterday = new Date();
        yesterday.setDate(yesterday.getDate() - 1);
        var today = new Date();
        
        GRIHFromDate.SetValue(yesterday);
        GRIHToDate.SetValue(today);

        GRIHDockLookup.SetValue();
        GridGRIHDockLookup.UnselectRows();
        GRIHSupplierLookup.SetValue();
        GridGRIHSupplierLookup.UnselectRows();

        GRIHRcvPlantCodeText.SetText();
        GRIHRouteRateText.SetText();
        GRIHManifestNoText.SetText();
        
//        GRIHStatusLookup.SetValue('Scanned');  
//        GridGRIHStatusLookup.SelectRowOnPage(2);
        GRIHStatusLookup.SetValue();
        GridGRIHStatusLookup.UnselectRows();

        GRIHDownloadPerManifestCheckbox.SetChecked(false);
        GRIDGridViewSelectAllCheckBox.SetChecked(false);

        GRIHOrderNoText.SetText();

        WarningLabel.SetVisible(false);

        GRIDGridView.ClearFilter();
        GRIDGridView.UnselectRows();

        GRIDGridView.PerformCallback();
    }

    function OnGRIHStatusLookupSelectAllCheckBoxCheckedChanged(s, e) {
        if (s.GetChecked()) 
            GridGRIHStatusLookup.SelectRows(); 
        else 
            GridGRIHStatusLookup.UnselectRows();
    }
    
    // ===========================================================================

    // ================== Goods Receipt Inquiry Detail Functions =================
    // Changed By   : fid.salman
    // Changed Date : 28.08.2013
    // Description  : Prevent multiple callback from ASPxClientGridView with disabling trigger control.
    function OnGoodsReceiptInquiryHeaderPartialButtonEnabled(isEnabled) {
        GRIHDownloadButton.SetEnabled(isEnabled);
        GRIHSHApproveButton.SetEnabled(isEnabled);
        GRIHCancelGRManifestButton.SetEnabled(isEnabled);
        GRIHToggleDetailButton.SetEnabled(isEnabled);
        GRIHSummaryButton.SetEnabled(isEnabled);
        GRIHSearchButton.SetEnabled(isEnabled);
        GRIHClearButton.SetEnabled(isEnabled);
    }

    function OnGRIDGridViewSelectAllCheckBoxCheckedChanged(s, e) {
//        GRIDGridViewSelectAllCheckBox.SetIsValid(true);
//        GRIDGridView.SelectAllRowsOnPage(GRIDGridViewSelectAllCheckBox.GetChecked());

        if (GRIDGridViewSelectAllCheckBox.GetChecked())
        {
            GRIDGridView.SelectRows();
        }
        else
        {
            GRIDGridView.UnselectRows();
        }
    }

    function OnUpdateManifestStatusSummary(s, e) {
        //add riani (20221012)
        var ManifestReceiveFlag_ = (GRIHStatusLookup.GetValue() == "Error in IPPCS")?"Error Posting":GRIHStatusLookup.GetValue();
        //-------------------//
        $.ajax({
                type: "POST",
                url: "@Url.Content("~/GoodsReceiptInquiry/PartialSlidingRightPaneContent")",
                dataType: "json",
                data: {
                    ArrivalTimeFrom: GetDatabaseFormatDate(GRIHFromDate.GetDate())
                    , ArrivalTimeTo: GetDatabaseFormatDate(GRIHToDate.GetDate())
                    , DockCode: GRIHDockLookup.GetValue()
                    , SupplierCode: GRIHSupplierLookup.GetValue()
                    , RcvPlantCode: GRIHRcvPlantCodeText.GetText()
                    , RouteRate: GRIHRouteRateText.GetText()
                    , ManifestNo: GRIHManifestNoText.GetText()
                    // , ManifestReceiveFlag: GRIHStatusLookup.GetValue()//edit riani (20221012)
                    , ManifestReceiveFlag: ManifestReceiveFlag_
                    //-----------------------------------------//
                    , OrderNo: GRIHOrderNoText.GetText()
                },
                success: function (result) {
                    var parameterValues = result.summary.split(';');

                    $("#OrderedSummaryLabel").text(parameterValues[0]);
                    $("#DeliveredSummaryLabel").text(parameterValues[1]);
                    $("#ScannedSummaryLabel").text(parameterValues[2]);
                    $("#ApprovedSummaryLabel").text(parameterValues[3]);
                    $("#PostedSummaryLabel").text(parameterValues[4]);
                    $("#ErrorPostingSummaryLabel").text(parameterValues[5]);
                    $("#InvoicedSummaryLabel").text(parameterValues[6]);
                    $("#PaidSummaryLabel").text(parameterValues[7]);
                    $("#CancelledSummaryLabel").text(parameterValues[8]);
                },
                error: function (result) {
                    alert("Error On Update Manifest Status Summary.");
                }
            });
    }

    var command = "";
    function OnGRIDGridViewBeginCallback(s, e) {
        OnGoodsReceiptInquiryHeaderPartialButtonEnabled(false);

        command = e.command;

        e.customArgs["ArrivalTimeFrom"] = GetDatabaseFormatDate(GRIHFromDate.GetDate());
        e.customArgs["ArrivalTimeTo"] = GetDatabaseFormatDate(GRIHToDate.GetDate());
        e.customArgs["DockCode"] = GRIHDockLookup.GetValue();
        e.customArgs["SupplierCode"] = GRIHSupplierLookup.GetValue();
        e.customArgs["RcvPlantCode"] = GRIHRcvPlantCodeText.GetText();
        e.customArgs["RouteRate"] = GRIHRouteRateText.GetText();
        e.customArgs["ManifestNo"] = GRIHManifestNoText.GetText();
        e.customArgs["ManifestReceiveFlag"] = GRIHStatusLookup.GetValue();
        e.customArgs["OrderNo"] = GRIHOrderNoText.GetText();
    }

    function OnGRIDGridViewEndCallback(s, e) {
        OnGoodsReceiptInquiryHeaderPartialButtonEnabled(true);
        WarningLabel.SetVisible(false);

//        GRIDGridViewSelectAllCheckBox.SetChecked(false);
//        GRIDGridView.SelectAllRowsOnPage(GRIDGridViewSelectAllCheckBox.GetChecked());

//        if (command == "PAGERONCLICK") {            
//            GRIDGridView.ClearFilter();
//            GRIDGridView.UnselectRows();
//        }

        OnUpdateManifestStatusSummary();
    }

    function OnGRIDGridViewInit(s, e) {
        OnGoodsReceiptInquiryHeaderPartialButtonEnabled(true);
    }

    function OnGRIDManifestDetailLinkClick(s, e) {
        var index = s.name.substring(22);
        //alert(index + ' - ' + s.name.substring(22));
        //index = index - (GRIDGridView.GetPageIndex() * GRIDGridView.cpPageSize);
        //---=== #240
        index = index;
        dockCode = GRIDGridView.cpDockCode[index];
        rcvPlantCode = GRIDGridView.cpRcvPlantCode[index];
        manifestNo = GRIDGridView.cpManifestNo[index];

        GoodsReceiptInquiryManifestDetailPopup.Show();
    }
    //OnGRIDEPGridViewBeginCallback
    function OnGRIDManifestDetailLinkErrorPostingClick(s, e) {
        var index = s.name.substring(34);
        ////alert(index + ' - ' + s.name.substring(22));
        ////index = index - (GRIDGridView.GetPageIndex() * GRIDGridView.cpPageSize);
        ////---=== #240
        index = index;
        dockCode = GRIDGridView.cpDockCode[index];
        rcvPlantCode = GRIDGridView.cpRcvPlantCode[index];
        manifestNo = GRIDGridView.cpManifestNo[index];

       
        GoodsReceiptInquiryManifestDetailPopupErrorPosting.Show();
    
    }

    function OnGRIDDelayFlagLinkClick (s, e) {
    }

    function OnGRIDProblemFlagLinkClick (s, e) {
        var index = s.name.substring(22);
        
        index = index - (GRIDGridView.GetPageIndex() * GRIDGridView.cpPageSize);
        
        dockCode = GRIDGridView.cpDockCode[index];
        rcvPlantCode = GRIDGridView.cpRcvPlantCode[index];
        manifestNo = GRIDGridView.cpManifestNo[index];

        GoodsReceiptInquiryManifestDetailPopup.Show();
    }

    // ===========================================================================

    // ========================== Common Popup Functions =========================

    function OnGoodsReceiptInquiryPopupBeginCallback(s, e) {
        
        e.customArgs["DockCode"] = dockCode;
        e.customArgs["RcvPlantCode"] = rcvPlantCode;
        e.customArgs["ManifestNo"] = manifestNo;
        
    }

    function OnGoodsReceiptInquiryPopupClosing(s, e) {
        GRIDGridView.PerformCallback();
    }

    // ===========================================================================

    // =========== Goods Receipt Inquiry Manifest Detail Popup Functions =========

    function OnGoodsReceiptInquiryManifestDetailPopupShown(s, e) {
        GoodsReceiptInquiryManifestDetailPopup.SetHeaderText("Goods Receipt Inquiry Manifest No " + manifestNo);
        GRIMDGridView.PerformCallback();
    }

    function OnGoodsReceiptInquiryManifestDetailPopupShownError(s, e) {
        GoodsReceiptInquiryManifestDetailPopupErrorPosting.SetHeaderText("Detail Error Manifest No " + manifestNo);
        GRIDEPGridView.PerformCallback();
    }

    function OnGRIMDGridViewBeginCallback(s, e) {
        e.customArgs["DockCode"] = dockCode;
        e.customArgs["RcvPlantCode"] = rcvPlantCode;
        e.customArgs["ManifestNo"] = manifestNo;
    }

      function OnGRIDEPGridViewBeginCallback(s, e) {
        e.customArgs["DockCode"] = dockCode;
        e.customArgs["RcvPlantCode"] = rcvPlantCode;
        e.customArgs["ManifestNo"] = manifestNo;
    }

    // ===========================================================================

    // ======= Goods Receipt Inquiry Download Confirmation Popup Functions =======

    function OnGoodsReceiptInquiryDownloadConfirmationPopupShown(s, e) {
        $("#GRIDCPArrivalTimeLabel").text(GetRegularFormatDate(arrivalTimeFrom) + " to " + GetRegularFormatDate(arrivalTimeTo));
        $("#GRIDCPDockLabel").text((dockCode) ? dockCode : "Not specified");
        $("#GRIDCPSupplierLabel").text((supplierCode) ? supplierCode : "Not specified");
        $("#GRIDCPRcvPlantLabel").text((rcvPlantCode) ? rcvPlantCode : "Not specified");
        $("#GRIDCPRouteRateLabel").text((routeRate) ? routeRate : "Not specified");
        $("#GRIDCPManifestNoLabel").text((manifestNo) ? manifestNo : "Not specified");
        $("#GRIDCPManifestReceiveFlagLabel").text((manifestReceiveFlag) ? manifestReceiveFlag : "");
        $("#GRIDCPOrderNoLabel").text((orderNo) ? orderNo : "Not specified");
    }

    function OnGRIDCPOkButtonClick(s, e) {
        GoodsReceiptInquiryDownloadConfirmationPopup.Hide();
        $("#GRIPPProgressLabel").text("Download in progress,\nPlease wait...");
        GoodsReceiptInquiryProgressPopup.Show();
        //add riani (20221012)
        manifestReceiveFlag = (manifestReceiveFlag == "Error in IPPCS") ? "Error Posting" : manifestReceiveFlag;
        //----------------------//
        $.fileDownload("GoodsReceiptInquiry/DownloadGoodsReceiptInquiry/", {
            data: {
                arrivalTimeFrom : arrivalTimeFrom,
                arrivalTimeTo : arrivalTimeTo,
                dockCode : dockCode,
                supplierCode : supplierCode,
                rcvPlantCode : rcvPlantCode,
                routeRate : routeRate,
                manifestNo : manifestNo,
                manifestReceiveFlag : manifestReceiveFlag,
                orderNo : orderNo,
                downloadBy : GRIHDownloadPerManifestCheckbox.GetValue()
            },
            successCallback: function (result) {
                GoodsReceiptInquiryProgressPopup.Hide();
            },
            failCallback: function (result) {
                GoodsReceiptInquiryProgressPopup.Hide();

                alert("Error On Download Goods Receipt Data.");
            }
        });
    }

    function OnGRIDCPCancelButtonClick(s, e) {
        GoodsReceiptInquiryDownloadConfirmationPopup.Hide();
    }

    // ===========================================================================

    // ======== Goods Receipt Inquiry Update Confirmation Popup Functions ========

    function OnGoodsReceiptInquiryUpdateConfirmationPopupShown(s, e) {
        GoodsReceiptInquiryUpdateConfirmationPopup.SetHeaderText("Goods Receipt Inquiry " + updateAction + " Confirmation");
    }
    

    function OnDownloadErrorButtonClick() {

        var parameter = "";
        var notErrorStatus = 0;

        if (GRIDGridView.GetSelectedRowCount() > 0) {
            for (var index = GRIDGridView.cpStartIndex; index < GRIDGridView.cpEndIndex; index++) {
                if (GRIDGridView.IsRowSelectedOnPage(index)) {

                    if (GRIDGridView.cpManifestReceiveFlag[index] != '5' && GRIDGridView.cpManifestReceiveFlag[index] != '9')//add riani (20220928)
                    {
                        notErrorStatus = 1;
                        break;
                    }

                    parameter += GRIDGridView.cpManifestNo[index] + ";";
                }
            }


            if (notErrorStatus != 1) {
                //download
                $.fileDownload("GoodsReceiptInquiry/downloadError/", {
                    data: {
                        param: parameter
                    },
                    successCallback: function (url) {

                    },
                    failCallback: function (result) {
                        alert(result);
                    }
                });
            }
            else {
                alert("Only Manifest with status \"Error Posting\" can be downloaded.");
            }
        }
        else {
            alert("No Data Selected.");
        }
    }



    function OnGRIUCPOkButtonClick() {
        if (updateAction == "Approve") {
            GoodsReceiptInquiryUpdateConfirmationPopup.Hide();

            $("#GRIPPProgressLabel").text("Approve in progress,\nPlease wait...");
            GoodsReceiptInquiryProgressPopup.Show();

            var isAmountValid = true;
            var isQtyValid = true;
            var isValid = true;
            var parameterList = "";
            var index;
            var counter;


            counter = 0;
            splitter = 1;

//            for (var overallIndex = GRIDGridView.GetTopVisibleIndex(); overallIndex < ((GRIDGridView.GetPageIndex() * GRIDGridView.cpPageSize) + GRIDGridView.GetVisibleRowsOnPage()); overallIndex++) {
            for (var index = GRIDGridView.cpStartIndex; index < GRIDGridView.cpEndIndex; index++) {
                if (GRIDGridViewSelectAllCheckBox.GetChecked()) 
                {
                    
                    parameterList += GRIDGridView.cpDockCode[index] + "|";
                    parameterList += GRIDGridView.cpSupplierCode[index] + "|";
                    parameterList += GRIDGridView.cpRcvPlantCode[index] + "|";
                    parameterList += GRIDGridView.cpManifestNo[index] + "|";
                    parameterList += GRIDGridView.cpOrderNo[index];
                    //parameterList += ";";

                    if (splitter == MAX_GR_PERPROCESS) {
                        parameterList += "~";
                        splitter = 1;
                    }
                    else {
                        splitter++;
                        parameterList += ";";
                    }

                    if (
                        (GRIDGridView.cpManifestReceiveFlag[index] != "2" && GRIDGridView.cpManifestReceiveFlag[index] != "3" && GRIDGridView.cpManifestReceiveFlag[index] != "5") ||
                        //(GRIDGridView.cpGRDocumentDt[index] != null && GRIDGridView.cpGRDocumentDt[index] != "") ||
                        //(GRIDGridView.cpApprovedBy[index] != null && GRIDGridView.cpApprovedBy[index] != "") ||
                        (GRIDGridView.cpCancelFlag[index] != null && GRIDGridView.cpCancelFlag[index] != '' && GRIDGridView.cpCancelFlag[index] != 0) ||
                        (GRIDGridView.cpDeletionFlag[index] != null && GRIDGridView.cpDeletionFlag[index] != '' && GRIDGridView.cpDeletionFlag[index] != 0) ||
                        (GRIDGridView.cpICSFlag[index] != null && GRIDGridView.cpICSFlag[index] != '' && GRIDGridView.cpICSFlag[index] != 0) //20210210 - FID.Ridwan -> handle if ics flag null / blank
                        )
                    {
                        isValid = false;
                    }
                    if ((GRIDGridView.cpTotalQty[index] == 0))
                        isQtyValid = false;

                    counter++;
                }
                else
                {
                    if (GRIDGridView.IsRowSelectedOnPage(index)) {
                     
                        //index = overallIndex - (GRIDGridView.GetPageIndex() * GRIDGridView.cpPageSize);        

                        parameterList += GRIDGridView.cpDockCode[index] + "|";
                        parameterList += GRIDGridView.cpSupplierCode[index] + "|";
                        parameterList += GRIDGridView.cpRcvPlantCode[index] + "|";
                        parameterList += GRIDGridView.cpManifestNo[index] + "|";
                        parameterList += GRIDGridView.cpOrderNo[index];
                        //parameterList += ";";

                        if (splitter == MAX_GR_PERPROCESS) {
                            parameterList += "~";
                            splitter = 1;
                        }
                        else {
                            splitter++;
                            parameterList += ";";
                        }

                        if (
                            (GRIDGridView.cpManifestReceiveFlag[index] != "2" && GRIDGridView.cpManifestReceiveFlag[index] != "3" && GRIDGridView.cpManifestReceiveFlag[index] != "5") ||
                            //(GRIDGridView.cpGRDocumentDt[index] != null && GRIDGridView.cpGRDocumentDt[index] != "") ||
                            //(GRIDGridView.cpApprovedBy[index] != null && GRIDGridView.cpApprovedBy[index] != "") ||
                            (GRIDGridView.cpCancelFlag[index] != null && GRIDGridView.cpCancelFlag[index] != '' && GRIDGridView.cpCancelFlag[index] != 0) ||
                            (GRIDGridView.cpDeletionFlag[index] != null && GRIDGridView.cpDeletionFlag[index] != '' && GRIDGridView.cpDeletionFlag[index] != 0) ||
                            (GRIDGridView.cpICSFlag[index] != null && GRIDGridView.cpICSFlag[index] != '' && GRIDGridView.cpICSFlag[index] != 0) //20210210 - FID.Ridwan -> handle if ics flag null / blank
                            )
                            isValid = false;
                        if ((GRIDGridView.cpTotalQty[index] == 0))
                            isQtyValid = false;

                        counter++;
                    }
                }
            }
            
            if (counter > MAX_GR_POST)
                isAmountValid = false;
                
            if (isAmountValid)
            {
                if (isValid)
                {
                    if (isQtyValid)
                    {
                        if (parameterList.length > 0) {
                            parameterList = parameterList.substring(0, parameterList.length - 1);
                            console.log(parameterList);
                                                    
                            $.ajax({
                                    type: "POST",
                                    url: "@Url.Content("~/GoodsReceiptInquiry/ApproveGoodsReceiptInquiry")",
                                    data: {   
                                        allParameterList: parameterList
                                    },
                                    success: function (result) { 
                                        GoodsReceiptInquiryProgressPopup.Hide();  

                                        if (result.length > 0) {
                                            $("#GRIIPMessageLabel").text(result);
                                        }
                                        else {
                                            $("#GRIIPMessageLabel").text("Approval is Finish");
                                        }
                                        GoodsReceiptInquiryInformationPopup.Show();

                                        GRIDGridView.UnselectAllRowsOnPage();
                                        GRIDGridView.PerformCallback(); 
                                    },
                                    error: function (result) {
                                        GoodsReceiptInquiryProgressPopup.Hide();
                                    
                                        if (result.length > 0) {
                                            $("#GRIIPMessageLabel").text("Error on SH Approve.");
                                            GoodsReceiptInquiryInformationPopup.Show();
                                        }

                                        GRIDGridView.UnselectAllRowsOnPage();  
                                        GRIDGridView.PerformCallback(); 
                                    }
                                });  
                        }
                        else {
                            GoodsReceiptInquiryProgressPopup.Hide();

                           $("#GRIIPMessageLabel").text("No data selected!");
                            GoodsReceiptInquiryInformationPopup.Show();
                        }
                    }
                    else
                    {
                        GoodsReceiptInquiryProgressPopup.Hide();

                        $("#GRIIPMessageLabel").text("Approve Failed! One of selected manifest(s) has zero quantity, please check again.");
                        GoodsReceiptInquiryInformationPopup.Show();
                    }
                }
                else {
                    GoodsReceiptInquiryProgressPopup.Hide();

                    $("#GRIIPMessageLabel").text("Approve Failed! You can only approve manifest(s) which status : Scanned, Approved, Error Posting.");
                    GoodsReceiptInquiryInformationPopup.Show();
                }
            }
            else
            {
                GoodsReceiptInquiryProgressPopup.Hide();

                $("#GRIIPMessageLabel").text("Approve Failed! You can only approve maximal " + MAX_GR_POST + " manifest.");
                GoodsReceiptInquiryInformationPopup.Show();
            }
            
        }
        else if (updateAction == "Cancel") {
            GoodsReceiptInquiryUpdateConfirmationPopup.Hide();

            $("#GRIPPProgressLabel").text("Cancel in progress,\nPlease wait...");
            GoodsReceiptInquiryProgressPopup.Show();
            
            var isAmountValid = true;
            var isQtyValid = true;
            var isValid = true;
            var parameterList = "";
            var index;
            var counter;

            counter = 0;
//            for (var overallIndex = GRIDGridView.GetTopVisibleIndex(); overallIndex < ((GRIDGridView.GetPageIndex() * GRIDGridView.cpPageSize) + GRIDGridView.GetVisibleRowsOnPage()); overallIndex++) {
            for (var index = GRIDGridView.cpStartIndex; index < GRIDGridView.cpEndIndex; index++) {
                if (GRIDGridViewSelectAllCheckBox.GetChecked()) 
                {
                    parameterList += GRIDGridView.cpDockCode[index] + "|";
                    parameterList += GRIDGridView.cpSupplierCode[index] + "|";
                    parameterList += GRIDGridView.cpRcvPlantCode[index] + "|";
                    parameterList += GRIDGridView.cpManifestNo[index] + "|";
                    parameterList += GRIDGridView.cpOrderNo[index];
                    parameterList += ";";

                    if (
                        //(GRIDGridView.cpManifestReceiveFlag[index] != "5") &&
                        (GRIDGridView.cpCancelFlag[index] != null && GRIDGridView.cpCancelFlag[index] != "" && GRIDGridView.cpCancelFlag[index] != 0) ||
                        (GRIDGridView.cpDeletionFlag[index] != null && GRIDGridView.cpDeletionFlag[index] != "" && GRIDGridView.cpDeletionFlag[index] != 0) ||
                        (GRIDGridView.cpICSFlag[index] != 1)
                        )
                        isValid = false;
                    if ((GRIDGridView.cpTotalQty[index] == 0))
                        isQtyValid = false;

                    counter++;
                }
                else
                {
                    if (GRIDGridView.IsRowSelectedOnPage(index)) {
                        //index = overallIndex - (GRIDGridView.GetPageIndex() * GRIDGridView.cpPageSize); 

                        parameterList += GRIDGridView.cpDockCode[index] + "|";
                        parameterList += GRIDGridView.cpSupplierCode[index] + "|";
                        parameterList += GRIDGridView.cpRcvPlantCode[index] + "|";
                        parameterList += GRIDGridView.cpManifestNo[index] + "|";
                        parameterList += GRIDGridView.cpOrderNo[index];
                        parameterList += ";";

                        if (
                            //(GRIDGridView.cpManifestReceiveFlag[index] != "5") &&
                            (GRIDGridView.cpCancelFlag[index] != null && GRIDGridView.cpCancelFlag[index] != "" && GRIDGridView.cpCancelFlag[index] != 0) ||
                            (GRIDGridView.cpDeletionFlag[index] != null && GRIDGridView.cpDeletionFlag[index] != "" && GRIDGridView.cpDeletionFlag[index] != 0) ||
                            (GRIDGridView.cpICSFlag[index] != 1)
                            )
                            isValid = false;
                        if ((GRIDGridView.cpTotalQty[index] == 0))
                            isQtyValid = false;

                        counter++;
                    }
                }
            }
        
            if (counter > MAX_GR_POST)
                isAmountValid = false;
                
            if (isAmountValid)
            {
                if (isValid)
                {            
                    if (isQtyValid)
                    {
                        if (parameterList.length > 0) {
                            parameterList = parameterList.substring(0, parameterList.length - 1);

                            $.ajax({
                                    type: "POST",
                                    url: "@Url.Content("~/GoodsReceiptInquiry/CancelGoodsReceiptInquiry")",
                                    data: {   
                                        parameterList: parameterList
                                    },
                                    success: function (result) {
                                        GoodsReceiptInquiryProgressPopup.Hide();

                                        if (result.length > 0) {
                                            $("#GRIIPMessageLabel").text(result);
                                        }
                                        else {
                                            $("#GRIIPMessageLabel").text("Cancellation is Finish");
                                        }
                                        GoodsReceiptInquiryInformationPopup.Show();

                                        GRIDGridView.UnselectAllRowsOnPage();
                                        GRIDGridView.PerformCallback();
                                    },
                                    error: function (result) {
                                        GoodsReceiptInquiryProgressPopup.Hide();

                                        if (result.length > 0) {
                                            $("#GRIIPMessageLabel").text("Errir on GR Cancel.");
                                            GoodsReceiptInquiryInformationPopup.Show();
                                        }

                                        GRIDGridView.UnselectAllRowsOnPage();
                                    }
                                });
                        }
                        else {
                            GoodsReceiptInquiryProgressPopup.Hide();

                            $("#GRIIPMessageLabel").text("No data selected!");
                            GoodsReceiptInquiryInformationPopup.Show();
                        }
                    }
                    else
                    {
                        GoodsReceiptInquiryProgressPopup.Hide();
                
                        $("#GRIIPMessageLabel").text("Cancel Failed! One of selected manifest(s) has zero quantity, please check again.");
                        GoodsReceiptInquiryInformationPopup.Show();    
                    }
                }
                else {
                    GoodsReceiptInquiryProgressPopup.Hide();
                
                    $("#GRIIPMessageLabel").text("Cancel Failed! You can only cancel manifest(s) which has been posted to ICS.");
                    GoodsReceiptInquiryInformationPopup.Show();
                }
            }
            else
            {
                GoodsReceiptInquiryProgressPopup.Hide();

                $("#GRIIPMessageLabel").text("Cancellation Failed! You can only cancel maximal " + MAX_GR_POST + " manifest.");
                GoodsReceiptInquiryInformationPopup.Show();
            }
        }
    }

    function OnGRIUCPCancelButtonClick(s, e) {
        GoodsReceiptInquiryUpdateConfirmationPopup.Hide();
    }

    // ===========================================================================

    // ============= Goods Receipt Inquiry Information Popup Functions ===========

    function OnGoodsReceiptInquiryInformationPopupShown(s, e)
    {
        GoodsReceiptInquiryInformationPopup.SetHeaderText("Goods Receipt Inquiry " + updateAction + " Information");
    }

    function OnGRIIPPOkButtonClick(s, e) {
        GoodsReceiptInquiryInformationPopup.Hide();
    }

    // ===========================================================================
</script>

<div style="display:table;border:1px solid #142B94; background-color:#DEECFD; padding:10px;float:left;">
    @Html.Action("PartialHeaderGoodsReceiptInquiry", "GoodsReceiptInquiry")
</div>
<div style="margin-left:10px;float:left;">
    @Html.DevExpress().Label(
        label =>
        {
            label.Name = "WarningLabel";
            label.ClientVisible = false;
            label.ControlStyle.CssClass = "Label";
            label.Text = "Please select Status!";
            label.Style.Add("font-weight", "bold");
            label.Style.Add("color", "Red");
            label.Style.Add("border", "2px solid Red");
            label.Style.Add("padding", "10px");
            label.Style.Add("float", "left");
        }).GetHtml()  
</div>
<div style="height: 15px;clear:both;">
</div>
<div> 
    @Html.Action("PartialDetailGoodsReceiptInquiry", "GoodsReceiptInquiry")
</div>

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "GoodsReceiptInquiryManifestDetailPopup";
    //settings.HeaderText = "Goods Receipt Inquiry Manifest Detail";
    settings.CallbackRouteValues = new { Controller = "GoodsReceiptInquiry", Action = "PartialPopupGoodsReceiptInquiryManifestDetail" };
    // settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
    settings.Height = System.Web.UI.WebControls.Unit.Percentage(50);
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ControlStyle.BackColor = System.Drawing.Color.Transparent;
    settings.ShowPageScrollbarWhenModal = true;

    settings.ClientSideEvents.BeginCallback = "OnGoodsReceiptInquiryPopupBeginCallback";
    settings.ClientSideEvents.Closing = "OnGoodsReceiptInquiryPopupClosing";
    settings.ClientSideEvents.Shown = "OnGoodsReceiptInquiryManifestDetailPopupShown";

    settings.SetContent(() =>
    {
        Html.RenderAction("PartialPopupGoodsReceiptInquiryManifestDetail", "GoodsReceiptInquiry");
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "GoodsReceiptInquiryManifestDetailPopupErrorPosting";
    //settings.HeaderText = "Detail Error Manifest No. ";
    settings.CallbackRouteValues = new { Controller = "GoodsReceiptInquiry", Action = "PartialPopupGoodsReceiptInquiryManifestDetailErrorPosting" };
    // settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
    settings.Height = System.Web.UI.WebControls.Unit.Percentage(50);
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ControlStyle.BackColor = System.Drawing.Color.Transparent;
    settings.ShowPageScrollbarWhenModal = true;

    settings.ClientSideEvents.BeginCallback = "OnGoodsReceiptInquiryPopupBeginCallback";
    settings.ClientSideEvents.Closing = "OnGoodsReceiptInquiryPopupClosing";
    settings.ClientSideEvents.Shown = "OnGoodsReceiptInquiryManifestDetailPopupShownError";

    settings.SetContent(() =>
    {
        Html.RenderAction("PartialPopupGoodsReceiptInquiryManifestDetailErrorPosting", "GoodsReceiptInquiry");
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "GoodsReceiptInquiryDownloadConfirmationPopup";
    settings.HeaderText = "Goods Receipt Inquiry Download Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(340);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.BeginCallback = "OnGoodsReceiptInquiryPopupBeginCallback";
    settings.ClientSideEvents.Closing = "OnGoodsReceiptInquiryPopupClosing";
    settings.ClientSideEvents.Shown = "OnGoodsReceiptInquiryManifestDetailPopupShownError";
    settings.SetContent(() =>
    {
        Html.RenderPartial("GoodsReceiptInquiryDownloadConfirmationPopupPartial", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "GoodsReceiptInquiryUpdateConfirmationPopup";
    //settings.HeaderText = "Goods Receipt Inquiry Update Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(170);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.BeginCallback = "OnGoodsReceiptInquiryPopupBeginCallback";
    settings.ClientSideEvents.Closing = "OnGoodsReceiptInquiryPopupClosing";
    settings.ClientSideEvents.Shown = "OnGoodsReceiptInquiryUpdateConfirmationPopupShown";
    settings.SetContent(() =>
    {
        Html.RenderPartial("GoodsReceiptInquiryUpdateConfirmationPopupPartial", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(
    settings => {
        settings.Name = "GoodsReceiptInquiryProgressPopup";
        settings.ShowHeader = false;
        settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
        settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
        settings.ScrollBars = ScrollBars.Auto;
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        settings.Modal = true;
        settings.CloseAction = CloseAction.CloseButton;
        settings.ShowPageScrollbarWhenModal = true;
        settings.SetContent(() =>
        {
            Html.RenderPartial("GoodsReceiptInquiryProgressPopupPartial", Model);
        });
    }).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "GoodsReceiptInquiryInformationPopup";
    //settings.HeaderText = "Goods Receipt Inquiry Information";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(170);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.BeginCallback = "OnGoodsReceiptInquiryPopupBeginCallback";
    settings.ClientSideEvents.Closing = "OnGoodsReceiptInquiryPopupClosing";
    settings.ClientSideEvents.Shown = "OnGoodsReceiptInquiryInformationPopupShown";
    settings.SetContent(() =>
    {
        Html.RenderPartial("GoodsReceiptInquiryInformationPopupPartial", Model);
    });
}).GetHtml()

@Html.Common().DevExpress().MessageBoard(
    msettings =>
    {
        msettings.Name = "GRIDMessageBoard";
        msettings.BoardName = "Goods Receipt Monitoring";
        msettings.Position = MessageBoardPosition.RIGHT;
    }).GetHtml()

@Html.Common().DevExpress().MessageBoard(
    msettings =>
    {
        msettings.Name = "GRIMDMessageBoard";
        msettings.BoardName = "Goods Receipt Monitoring";
        msettings.Position = MessageBoardPosition.RIGHT;
    }).GetHtml()

    